using Indotalent.ConfigBackEnd.Exceptions;
using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Pipeline.SalesTeam.Cqrs;

public class UpdateSalesTeamRequest
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public class UpdateSalesTeamResponse
{
    public string? Id { get; set; }
    public bool Success { get; set; }
}

public record UpdateSalesTeamCommand(UpdateSalesTeamRequest Data) : IRequest<UpdateSalesTeamResponse>;

public class UpdateSalesTeamHandler : IRequestHandler<UpdateSalesTeamCommand, UpdateSalesTeamResponse>
{
    private readonly AppDbContext _context;

    public UpdateSalesTeamHandler(AppDbContext context) => _context = context;

    public async Task<UpdateSalesTeamResponse> Handle(UpdateSalesTeamCommand request, CancellationToken cancellationToken)
    {
        var isExists = await _context.SalesTeam
            .AnyAsync(x => x.Name == request.Data.Name && x.Id != request.Data.Id, cancellationToken);

        if (isExists)
        {
            throw new AlreadyExistsException("Sales Team", request.Data.Name ?? string.Empty);
        }

        var entity = await _context.SalesTeam
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null)
        {
            return new UpdateSalesTeamResponse { Id = request.Data.Id, Success = false };
        }

        entity.Name = request.Data.Name;
        entity.Description = request.Data.Description;

        await _context.SaveChangesAsync(cancellationToken);

        return new UpdateSalesTeamResponse
        {
            Id = entity.Id,
            Success = true
        };
    }
}